import java.util.*;
public class TST {

    public class TSTNode {
	TSTNode eqkid;
	TSTNode lokid;
	TSTNode hikid;
	Integer split;
	Integer value;
	public TSTNode(Integer s) {
	    split = s;
	    value = -1;
	}

	public String toString() {
	    String s = new String();
	    s+= "(split = " + split + ", lokid = " + lokid + ", eqkid = "+ eqkid + " hikid = "+ hikid + ", value = " +value+")"; 
	    return s;
	}
    }
    TSTNode root;
    
    
    /* search in a tst 
	 */
	public TSTNode TSTSearch(Integer[] s) {
	    return TSTSearch(root, s, 0);
	}
	
	public TSTNode TSTSearch(TSTNode p, Integer[] s, int i) {
	    //	    System.out.println("searching... p = " +p + ", at pos " + i +" : " + s[i]);
	    if (p == null) return null;
	    if (s[i] < p.split)
		return TSTSearch(p.lokid, s, i);
	    else if (s[i] > p.split) 
		return TSTSearch(p.hikid, s, i);
	    else {
		if (s.length-1 == i) return p;
		return TSTSearch(p.eqkid, s, i+1);
	    }
	}
	
	/* insert in a tst
	 */
	
	
	public void TSTInsert(Integer[] s) {
	    TSTNode q = null;
	    root = TSTInsert(root, s, 0);
	}
	
	public TSTNode TSTInsert(TSTNode p, Integer[] s, int i) {
	    //	    System.out.println("p = " +p + ", at pos " + i +" : " + s[i]);
	    if (p == null) {
		p = new TSTNode(s[i]);
	    }
	    if (s[i] < p.split)
		p.lokid = TSTInsert(p.lokid, s, i);
	    else if (s[i] == p.split) {
		if (i < s.length -1)
		    p.eqkid = TSTInsert(p.eqkid, s, i+1);
	    } else 
		p.hikid = TSTInsert(p.hikid, s, i);
	    //	    System.out.println(" p = " + p);
	    return p;
	}
	public void TSTInsertValue(Integer[] s, int v) {
	    TSTNode q = null;
	    root = TSTInsertValue(root, s, 0, v);
	}
	
	public TSTNode TSTInsertValue(TSTNode p, Integer[] s, int i, int v) {
	    //	    System.out.println("p = " +p + ", at pos " + i +" : " + s[i]);
	    if (p == null) {
		p = new TSTNode(s[i]);
	    }
	    if (s[i] < p.split)
		p.lokid = TSTInsertValue(p.lokid, s, i, v);
	    else if (s[i] == p.split) {
		if (i < s.length -1)
		    p.eqkid = TSTInsertValue(p.eqkid, s, i+1, v);
		else {
		    p.value = v;
		}
	    } else 
		p.hikid = TSTInsertValue(p.hikid, s, i, v);
	    //	    System.out.println(" p = " + p);
	    return p;
	}
	
	public void put(Integer[] s, int v) {
	    TSTInsertValue(s, v);
	}
	
	public int get(Integer[] s) {
	    TSTNode p = TSTSearch(s);
	    if (p != null) 
		return p.value;
	    else return -1;
	}
	
	public void TstTraverseAux(TSTNode p, int[] s, int i, String out) {
	    if (p != null) {
		TstTraverseAux(p.lokid,s,i, out);
		s[i]=p.split;
		if (p.value != -1) {
		    out += "([";
		    for (int j=0; j < i; j++) {
			out+= s[i] + " ";
		    }
		    out+= "] = "+ p.value + ")\n";
		}
		TstTraverseAux(p.eqkid, s, i+1, out);
		TstTraverseAux(p.hikid, s, i, out);
	    }
	}
	
	public String toString() {
	    int[] word = new int[100];
	    String s = new String();
	    TstTraverseAux(root,word,0, s );
	    return s;
	}
    private static final Comparator<Integer[]> 
	keyComparator = new Comparator<Integer[]>() {
	    public int compare(Integer[] as, Integer[] bs) {
		int result;
		if ((result = as.length - bs.length) != 0) { 
		    return result;
		}
		int length = as.length;
		int i = 0;
		while (i < length && (result =as[i] -bs[i]) == 0) {
		    i++;
		}
		return result;
	    }
	    public boolean equal(Integer[] as, Integer[] bs) {
		return compare(as, bs) == 0;
	    }

	};
	public void TstTraversekeySet(TSTNode p, Integer[] s, int i, 
				      Set<Integer[]> out) {
	    if (p != null) {
		TstTraversekeySet(p.lokid,s,i, out);
		s[i]=p.split;
		if (p.value != -1) {
		    Integer [] t = new Integer[i];
		    System.arraycopy(s, 0, t, 0, i);
		    out.add(t);
		}
		TstTraversekeySet(p.eqkid, s, i+1, out);
		TstTraversekeySet(p.hikid, s, i, out);
	    }
	}
	

	public Set<Integer[]> keySet() {
	    Integer[] word = new Integer[100];
	    Set<Integer[]> s = new TreeSet<Integer[]>(keyComparator);
	    TstTraversekeySet(root,word,0, s );
	    return s;
	}

	
    }
