import java.util.*;
import java.io.*;
public class fullNFA {
    public static NFA Complex(int h){
	NFA a = new NFA(h);
	int i = a.newState();
	a.SetInitial(i);
	int p = a.newState();
	a.addEdge(i, 'a', p);
	for (int j = 1; j < h-1; j++) {
	    int q = a.newState();
	    a.addEdge(p, 'a', q);
	    a.addEdge(p, 'b', p);
	    a.addEdge(p, 'c', p);
	    a.addEdge(p, 'c', i);
	    p = q;
	}
	a.SetTerminal(p);
	a.addEdge(p, 'a', i);
	a.addEdge(p, 'b', p);
	a.addEdge(p, 'c', p);
	a.addEdge(p, 'c', i);
	return a;
    }
    


    public static void testfull(String[] args) {
	long time;
	int size = Integer.parseInt(args[0]);
	int choice;
	if (args.length > 1) {
	    choice = Integer.parseInt(args[1]);
	}
	else {
	    choice = -1;
	}
	NFA a = Complex(size);
	//	System.out.println("NFA:" + a);
	System.out.println("size of the NFA = " + size);
	time = System.currentTimeMillis();
	DFA c;
	switch (choice) {
	case 1: 
	    System.out.println("Determinisation avec 'Map<Set<Integer>, Integer>'");
	    c = a.toDFA();
	    break;
	case 2: 
	    System.out.println("Determinisation avec 'Map<Integer[], Integer>'");
	    c = a.toDFA1();
	    break;
	case 3: 
	    System.out.println("Determinisation avec 'TST'");

	    c = a.toDFA2();
	    break;
	default:
	    System.out.println("Determinisation avec 'Map<Set<Integer>, Integer>'");
	    c = a.toDFA();
	    break;
	}
	System.out.println("Elapsed time for DFA1 = " + 
		   (System.currentTimeMillis() - time) +" ms");	
	System.out.println("size of the DFA = " + c.nbStates);
	//	System.out.println("DFA:" + c);

    }
  
    public static void main(String[] args) throws Exception {
	testfull(args);
    }
}
